GNU bug report logs - #6227
Color isearch regexp submatches differently

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: Lennart Borgman <lennart.borgman@HIDDEN>; dated Thu, 20 May 2010 11:13:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 11 Jun 2010 08:18:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 11 04:18:54 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OMzS2-0004Lm-94
	for submit <at> debbugs.gnu.org; Fri, 11 Jun 2010 04:18:54 -0400
Received: from smtp-out2.starman.ee ([85.253.0.4] helo=mx2.starman.ee)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <juri@HIDDEN>) id 1OMzRz-0004LX-Ih
	for 6227 <at> debbugs.gnu.org; Fri, 11 Jun 2010 04:18:51 -0400
X-Virus-Scanned: by Amavisd-New at mx2.starman.ee
Received: from mail.starman.ee (82.131.28.166.cable.starman.ee [82.131.28.166])
	by mx2.starman.ee (Postfix) with ESMTP id 151093F40BB;
	Fri, 11 Jun 2010 11:18:45 +0300 (EEST)
From: Juri Linkov <juri@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Organization: JURTA
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN>
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN>
	<AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN>
	<8739ww1tjp.fsf@HIDDEN>
	<AANLkTilwC3QBYmtzPg3zrDoD44deoBsD5rxxP-dNhxnH@HIDDEN>
	<87d3vyaodq.fsf@HIDDEN> <87hbla4nl4.fsf@HIDDEN>
	<AANLkTinO7qf82Y6PiswHZn0Uu7G6dlJYfD6ufOzWcRGz@HIDDEN>
	<jwvzkz21jq3.fsf-monnier+emacs@HIDDEN>
Date: Fri, 11 Jun 2010 11:17:19 +0300
In-Reply-To: <jwvzkz21jq3.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
	of "Thu, 10 Jun 2010 20:44:42 -0400")
Message-ID: <87631qugyg.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 6227
Cc: Lennart Borgman <lennart.borgman@HIDDEN>, 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

>> but set I suggest a default of 100. The loop costs essentially nothing
>> for non-submatches and this is on command level.
>
> (/ (length (match-data)) 2)

Then the loop should iterate from 1 up to the minimum of
`(/ (length (match-data)) 2)' and `search-highlight-submatches'.

As for the faces, perhaps we should dynamically create submatch faces
like in `vc-annotate-lines' that uses `vc-annotate-color-map'.

-- 
Juri Linkov
http://www.jurta.org/emacs/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 11 Jun 2010 00:44:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 10 20:44:48 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OMsMZ-0008Ht-IB
	for submit <at> debbugs.gnu.org; Thu, 10 Jun 2010 20:44:47 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.181]
	helo=ironport2-out.pppoe.ca)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <monnier@HIDDEN>) id 1OMsMY-0008Hn-BC
	for 6227 <at> debbugs.gnu.org; Thu, 10 Jun 2010 20:44:46 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AvsEADcjEUxMCqeQ/2dsb2JhbACed3K+f4UYBIx1
X-IronPort-AV: E=Sophos;i="4.53,400,1272859200"; d="scan'208";a="67812592"
Received: from 76-10-167-144.dsl.teksavvy.com (HELO pastel.home)
	([76.10.167.144])
	by ironport2-out.pppoe.ca with ESMTP; 10 Jun 2010 20:44:42 -0400
Received: by pastel.home (Postfix, from userid 20848)
	id 3000E8056; Thu, 10 Jun 2010 20:44:42 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Lennart Borgman <lennart.borgman@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Message-ID: <jwvzkz21jq3.fsf-monnier+emacs@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN>
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN>
	<AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN>
	<8739ww1tjp.fsf@HIDDEN>
	<AANLkTilwC3QBYmtzPg3zrDoD44deoBsD5rxxP-dNhxnH@HIDDEN>
	<87d3vyaodq.fsf@HIDDEN> <87hbla4nl4.fsf@HIDDEN>
	<AANLkTinO7qf82Y6PiswHZn0Uu7G6dlJYfD6ufOzWcRGz@HIDDEN>
Date: Thu, 10 Jun 2010 20:44:42 -0400
In-Reply-To: <AANLkTinO7qf82Y6PiswHZn0Uu7G6dlJYfD6ufOzWcRGz@HIDDEN>
	(Lennart Borgman's message of "Thu, 10 Jun 2010 23:41:40 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -2.2 (--)
X-Debbugs-Envelope-To: 6227
Cc: Juri Linkov <juri@HIDDEN>, 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.2 (--)

> but set I suggest a default of 100. The loop costs essentially nothing
> for non-submatches and this is on command level.

(/ (length (match-data)) 2)


        Stefan




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 10 Jun 2010 21:42:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 10 17:42:07 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OMpVn-00072P-4J
	for submit <at> debbugs.gnu.org; Thu, 10 Jun 2010 17:42:07 -0400
Received: from mail-gw0-f44.google.com ([74.125.83.44])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OMpVk-000721-Oi
	for 6227 <at> debbugs.gnu.org; Thu, 10 Jun 2010 17:42:05 -0400
Received: by gwj16 with SMTP id 16so315770gwj.3
	for <6227 <at> debbugs.gnu.org>; Thu, 10 Jun 2010 14:42:00 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type
	:content-transfer-encoding;
	bh=zc1UPflD6usNf4FpaU/PYsD9g+OQ6QaJwwORqzJUtMU=;
	b=i7H6TH2HnADsKmbmUEF9UrUDnbTCPnkvw4UpgWQbgBq7tAx0e5coF/OMct6EXSWhNN
	xSI4W62EC+rYx0ow6Fi4VG7wya9uzuUaBMVbKM5rLlfwvpZMfkU31aHoe/EPBO3LR4Nx
	OSu9+4VenOmp0A78CEp02T2lwSUzGaqkZuo5I=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type:content-transfer-encoding;
	b=EE4IyNKXIWvRNvK4Hh8DrllbZqkYq+S60OjMtfGBnAFuJQ2UmVzWxCU3BkWwShDw9S
	UUMlHPaC/5ZSuDPxaU4XjmWw4+yqi74VnRpRS1mK2T3jcS44jpht5QJUmYLcxv9bZmS3
	Vo3tS9VDV8XsprT+NbgJoOWhIaeJsJuaSy2hE=
Received: by 10.101.201.37 with SMTP id d37mr802030anq.56.1276206120309; Thu, 
	10 Jun 2010 14:42:00 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.154.15 with HTTP; Thu, 10 Jun 2010 14:41:40 -0700 (PDT)
In-Reply-To: <87hbla4nl4.fsf@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN> 
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN> 
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN> 
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN> 
	<AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN> 
	<8739ww1tjp.fsf@HIDDEN>
	<AANLkTilwC3QBYmtzPg3zrDoD44deoBsD5rxxP-dNhxnH@HIDDEN> 
	<87d3vyaodq.fsf@HIDDEN> <87hbla4nl4.fsf@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Thu, 10 Jun 2010 23:41:40 +0200
Message-ID: <AANLkTinO7qf82Y6PiswHZn0Uu7G6dlJYfD6ufOzWcRGz@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -3.0 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.0 (---)

On Thu, Jun 10, 2010 at 10:52 PM, Juri Linkov <juri@HIDDEN> wrote:
>>> I agree, your approach is probably better. But check for more
>>> submatches. Maybe upto the value of some variable, say
>>> isearch-max-submatch-num.
>>
>> Good idea.
>
> Maybe something like this:

Yes,

> +(defcustom search-highlight-submatches 0

but set I suggest a default of 100. The loop costs essentially nothing
for non-submatches and this is on command level.

> + =C2=A0 =C2=A0(let ((i 0) ov)
> + =C2=A0 =C2=A0 =C2=A0(while (<=3D i search-highlight-submatches)
> + =C2=A0 =C2=A0 =C2=A0 (when (match-beginning i)
> + =C2=A0 =C2=A0 =C2=A0 =C2=A0 (setq ov (make-overlay (match-beginning i) =
(match-end i)))
> + =C2=A0 =C2=A0 =C2=A0 =C2=A0 (overlay-put ov 'face (intern-soft (format =
"isearch-%d" i)))
> + =C2=A0 =C2=A0 =C2=A0 =C2=A0 (overlay-put ov 'priority 1002)
> + =C2=A0 =C2=A0 =C2=A0 =C2=A0 (push ov isearch-submatches-overlays))
> + =C2=A0 =C2=A0 =C2=A0 (setq i (1+ i))))))




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 10 Jun 2010 20:54:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 10 16:54:14 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OMolS-0006gM-2g
	for submit <at> debbugs.gnu.org; Thu, 10 Jun 2010 16:54:14 -0400
Received: from smtp-out1.starman.ee ([85.253.0.3] helo=mx1.starman.ee)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <juri@HIDDEN>) id 1OMolP-0006gE-LA
	for 6227 <at> debbugs.gnu.org; Thu, 10 Jun 2010 16:54:12 -0400
X-Virus-Scanned: by Amavisd-New at mx1.starman.ee
Received: from mail.starman.ee (82.131.99.15.cable.starman.ee [82.131.99.15])
	by mx1.starman.ee (Postfix) with ESMTP id 0DCE73F40BA;
	Thu, 10 Jun 2010 23:53:57 +0300 (EEST)
From: Juri Linkov <juri@HIDDEN>
To: Lennart Borgman <lennart.borgman@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Organization: JURTA
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN>
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN>
	<AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN>
	<8739ww1tjp.fsf@HIDDEN>
	<AANLkTilwC3QBYmtzPg3zrDoD44deoBsD5rxxP-dNhxnH@HIDDEN>
	<87d3vyaodq.fsf@HIDDEN>
Date: Thu, 10 Jun 2010 23:52:39 +0300
In-Reply-To: <87d3vyaodq.fsf@HIDDEN> (Juri Linkov's message of "Thu,
	10 Jun 2010 18:28:57 +0300")
Message-ID: <87hbla4nl4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

>> I agree, your approach is probably better. But check for more
>> submatches. Maybe upto the value of some variable, say
>> isearch-max-submatch-num.
>
> Good idea.

Maybe something like this:

=== modified file 'lisp/isearch.el'
--- lisp/isearch.el	2010-06-10 14:32:41 +0000
+++ lisp/isearch.el	2010-06-10 20:51:43 +0000
@@ -223,6 +223,15 @@ (defcustom search-highlight t
   :type 'boolean
   :group 'isearch)
 
+(defcustom search-highlight-submatches 0
+  "Highlight regexp subexpressions of the current regexp match.
+An integer means highlight regexp subexpressions up to the
+specified maximal number.
+When 0, do not highlight regexp subexpressions."
+  :type 'integer
+  :version "24.1"
+  :group 'isearch)
+
 (defface isearch
   '((((class color) (min-colors 88) (background light))
      ;; The background must not be too dark, for that means
@@ -2526,6 +2535,23 @@ (defun isearch-unread (&rest char-or-eve
 ;; Highlighting
 
 (defvar isearch-overlay nil)
+(defvar isearch-submatches-overlays nil)
+
+(defface isearch-1
+  '((((class color) (min-colors 88) (background light))
+     :background "magenta2" :foreground "lightskyblue1")
+    (((class color) (min-colors 88) (background dark))
+     :background "palevioletred3" :foreground "brown4"))
+  "Used for displaying the first matching subexpression."
+  :group 'isearch)
+
+(defface isearch-2
+  '((((class color) (min-colors 88) (background light))
+     :background "magenta1" :foreground "lightskyblue1")
+    (((class color) (min-colors 88) (background dark))
+     :background "palevioletred4" :foreground "brown4"))
+  "Used for displaying the second matching subexpression."
+  :group 'isearch)
 
 (defun isearch-highlight (beg end)
   (if search-highlight
@@ -2536,11 +2562,28 @@ (defun isearch-highlight (beg end)
 	(setq isearch-overlay (make-overlay beg end))
 	;; 1001 is higher than lazy's 1000 and ediff's 100+
 	(overlay-put isearch-overlay 'priority 1001)
-	(overlay-put isearch-overlay 'face isearch))))
+	(overlay-put isearch-overlay 'face isearch)))
+  (when (and (integerp search-highlight-submatches)
+	     (> search-highlight-submatches 0)
+	     isearch-regexp)
+    (mapc 'delete-overlay isearch-submatches-overlays)
+    (setq isearch-submatches-overlays nil)
+    (let ((i 0) ov)
+      (while (<= i search-highlight-submatches)
+	(when (match-beginning i)
+	  (setq ov (make-overlay (match-beginning i) (match-end i)))
+	  (overlay-put ov 'face (intern-soft (format "isearch-%d" i)))
+	  (overlay-put ov 'priority 1002)
+	  (push ov isearch-submatches-overlays))
+	(setq i (1+ i))))))
 
 (defun isearch-dehighlight ()
   (when isearch-overlay
-    (delete-overlay isearch-overlay)))
+    (delete-overlay isearch-overlay))
+  (when search-highlight-submatches
+    (mapc 'delete-overlay isearch-submatches-overlays)
+    (setq isearch-submatches-overlays nil)))
+
 
 ;; isearch-lazy-highlight feature
 ;; by Bob Glickstein <http://www.zanshin.com/~bobg/>

-- 
Juri Linkov
http://www.jurta.org/emacs/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 10 Jun 2010 15:52:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 10 11:52:48 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OMk3k-0004Lz-64
	for submit <at> debbugs.gnu.org; Thu, 10 Jun 2010 11:52:48 -0400
Received: from mail-gy0-f172.google.com ([209.85.160.172])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OMk3i-0004Li-HF
	for 6227 <at> debbugs.gnu.org; Thu, 10 Jun 2010 11:52:46 -0400
Received: by gyh4 with SMTP id 4so43400gyh.3
	for <6227 <at> debbugs.gnu.org>; Thu, 10 Jun 2010 08:52:41 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type;
	bh=9SVDDhkMWTr65y7TCEMqswP/xnMG+pbSLMGStEnpK7s=;
	b=FBaA5hWFI8ybWbRy1oQAREee6ebVX1eH40jSSYpcZjc7/wUO+OG5TKZMn/TGDRkKpO
	lQenzGcEy1j27Be2dUPICQPt4Mvy08Oais663O4sHjfTrb29IiSaSRrwRWe5EcrRA006
	fV+qQgTneH8qsiVUxHcb0xE7O8QWpecH3IWqI=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type;
	b=gF7O4GnHmJfeyM9DpmAy3nyKZuRpVe31jxTl5812uyI3GZfuEzVhM2bcjbjNJ9Hm6i
	tlav/FKoHXcBrtdzsQzr1Nd7WsABPUGwXheJOYwnCnVRPmjZ/LNOWNhlg3s0V0jZTiph
	bZ2SNBooeAPd3lc0L4t9lI5LkslyB7w0pibtg=
Received: by 10.101.145.16 with SMTP id x16mr333625ann.226.1276185161450; Thu, 
	10 Jun 2010 08:52:41 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.154.15 with HTTP; Thu, 10 Jun 2010 08:52:21 -0700 (PDT)
In-Reply-To: <87d3vyaodq.fsf@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN> 
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN> 
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN> 
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN> 
	<AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN> 
	<8739ww1tjp.fsf@HIDDEN>
	<AANLkTilwC3QBYmtzPg3zrDoD44deoBsD5rxxP-dNhxnH@HIDDEN> 
	<87d3vyaodq.fsf@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Thu, 10 Jun 2010 17:52:21 +0200
Message-ID: <AANLkTinVYv17wGyMSorZWIOwZA5jcFCFX1FFfaPD6bHZ@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -2.9 (--)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.9 (--)

On Thu, Jun 10, 2010 at 5:28 PM, Juri Linkov <juri@HIDDEN> wrote:
>>>> (It includes a bug fix for the prompt face too
>>>
>>> What's a bug in the prompt face?
>>
>> There is a variable, minibuffer-prompt-properties, that holds the name
>> of the face to use. I think this should be used for consistency. It
>> makes it much easier for users.
>
> Why do you remove `read-only' with `(propertize m2 'read-only nil)'?
> What was a problem with `read-only' in the isearch prompt?

Hm, can't remember. I did this quite a while ago. I just tested and it
seems to work without that. Probably it is something I forgot to
remove after testing.

>>>> and a help window scrolling I think is useful.)
>>>
>>> Please provide an example of the scrolling bug too.
>>
>> I am not sure on that one. Maybe I just forgot to remove it when you
>> implemented your way of doing it?
>
> I see no scrolling problems after setting `isearch-allow-scroll' to t.

Seems that you are right. Fine, just skip that part of the patch.




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 10 Jun 2010 15:39:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 10 11:39:42 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OMjr4-0004Fy-KL
	for submit <at> debbugs.gnu.org; Thu, 10 Jun 2010 11:39:42 -0400
Received: from smtp-out1.starman.ee ([85.253.0.3] helo=mx1.starman.ee)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <juri@HIDDEN>) id 1OMjr2-0004Fe-J6
	for 6227 <at> debbugs.gnu.org; Thu, 10 Jun 2010 11:39:41 -0400
X-Virus-Scanned: by Amavisd-New at mx1.starman.ee
Received: from mail.starman.ee (82.131.99.15.cable.starman.ee [82.131.99.15])
	by mx1.starman.ee (Postfix) with ESMTP id 57BF93F40B8;
	Thu, 10 Jun 2010 18:39:32 +0300 (EEST)
From: Juri Linkov <juri@HIDDEN>
To: Lennart Borgman <lennart.borgman@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Organization: JURTA
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN>
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN>
	<AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN>
	<8739ww1tjp.fsf@HIDDEN>
	<AANLkTilwC3QBYmtzPg3zrDoD44deoBsD5rxxP-dNhxnH@HIDDEN>
Date: Thu, 10 Jun 2010 18:28:57 +0300
In-Reply-To: <AANLkTilwC3QBYmtzPg3zrDoD44deoBsD5rxxP-dNhxnH@HIDDEN>
	(Lennart Borgman's message of "Wed, 9 Jun 2010 11:14:03 +0200")
Message-ID: <87d3vyaodq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

>>> (It includes a bug fix for the prompt face too
>>
>> What's a bug in the prompt face?
>
> There is a variable, minibuffer-prompt-properties, that holds the name
> of the face to use. I think this should be used for consistency. It
> makes it much easier for users.

Why do you remove `read-only' with `(propertize m2 'read-only nil)'?
What was a problem with `read-only' in the isearch prompt?

>>> and a help window scrolling I think is useful.)
>>
>> Please provide an example of the scrolling bug too.
>
> I am not sure on that one. Maybe I just forgot to remove it when you
> implemented your way of doing it?

I see no scrolling problems after setting `isearch-allow-scroll' to t.

> I agree, your approach is probably better. But check for more
> submatches. Maybe upto the value of some variable, say
> isearch-max-submatch-num.

Good idea.

-- 
Juri Linkov
http://www.jurta.org/emacs/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 9 Jun 2010 09:14:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 09 05:14:28 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OMHMi-0005OU-CY
	for submit <at> debbugs.gnu.org; Wed, 09 Jun 2010 05:14:28 -0400
Received: from mail-yw0-f196.google.com ([209.85.211.196])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OMHMg-0005OP-Mc
	for 6227 <at> debbugs.gnu.org; Wed, 09 Jun 2010 05:14:27 -0400
Received: by ywh34 with SMTP id 34so5456727ywh.30
	for <6227 <at> debbugs.gnu.org>; Wed, 09 Jun 2010 02:14:23 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type
	:content-transfer-encoding;
	bh=gUiMwKCtZqRacd3rS9C9y9YRO/okopg7Nq4WySD0msw=;
	b=kv9BkxtZZDIow3TZEvdjy4tZRAgjle3LbThSBIsUXEkQXEmSUojHaw5VOOeDSDR678
	ucBNdTsVaA5wQadFD9/W/y4I23Px7iCDS8/DLrGIrBobQ0EXPVGjkPCGVm2dgF8J8nIO
	02NCDUxRZQdtHoo+rjkUGBkfCo2VRdcz3a57U=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type:content-transfer-encoding;
	b=rnsmqfA261F2dH9zEDWLljlKhtfBRadT+LH1Ue15JQ6ZUKz+2i3gyPiLd7rcj6mfP2
	ihxYJFB6Xlr5NsqNmLBdsTcfNXohswRQyy3ybqDDFhJHIITRoeMG+f0QG6e7XW3WczGd
	7AYoIueOSWRO6X36IonE0WxBhPLjocBrKYBIw=
Received: by 10.101.133.9 with SMTP id k9mr18054070ann.43.1276074863250; Wed, 
	09 Jun 2010 02:14:23 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.154.15 with HTTP; Wed, 9 Jun 2010 02:14:03 -0700 (PDT)
In-Reply-To: <8739ww1tjp.fsf@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN> 
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN> 
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN> 
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN> 
	<AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN> 
	<8739ww1tjp.fsf@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Wed, 9 Jun 2010 11:14:03 +0200
Message-ID: <AANLkTilwC3QBYmtzPg3zrDoD44deoBsD5rxxP-dNhxnH@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.9 (--)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.9 (--)

On Wed, Jun 9, 2010 at 10:36 AM, Juri Linkov <juri@HIDDEN> wrote:
>> Here is a patch for the submatches highlighting.
>> (It includes a bug fix for the prompt face too
>
> What's a bug in the prompt face?


There is a variable, minibuffer-prompt-properties, that holds the name
of the face to use. I think this should be used for consistency. It
makes it much easier for users.


>> and a help window scrolling I think is useful.)
>
> Please provide an example of the scrolling bug too.


I am not sure on that one. Maybe I just forgot to remove it when you
implemented your way of doing it?


>> The current faces does not look very well together so that must be fixed=
.
>
> If current faces does not look well, then maybe we should completely
> get rid of using re-builder.el in isearch, its faces and messy functions
> like count-subexps, and to write this functionality for isearch from scra=
tch.


I thought maybe something like count-subexps is needed now with the
numbered submatches.


> Do you think something more complicated is necessary for this
> functionality than the following simple code:
>
> (defvar isearch-sub-overlays nil)
> (add-hook 'isearch-update-post-hook
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(lambda ()
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0;; This code could be added to `=
isearch-highlight'.
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(mapc 'delete-overlay isearch-su=
b-overlays)
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(setq isearch-sub-overlays nil)
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(when isearch-regexp
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(dolist (i '(1 2 3 4))
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(when (match-begin=
ning i)
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(let ((ov (=
make-overlay (match-beginning i) (match-end i))))
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(ove=
rlay-put ov 'face (intern-soft (format "isearch-%d" i)))
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(ove=
rlay-put ov 'priority 1002)
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(pus=
h ov isearch-sub-overlays)))))))


It does not take care of numbered matches. But, yes, why not guess? I
agree, your approach is probably better. But check for more
submatches. Maybe upto the value of some variable, say
isearch-max-submatch-num.


> It relies on new faces `isearch-1', `isearch-2', `isearch-3', `isearch-4'=
.
> As for face colors, I tried "magenta1", "magenta2", "magenta3", "magenta4=
"
> for background colors, and they look good.


The problem with mixing isearch faces with re-builder dito was the
resulting colors from merging. If it works then just use your
suggestions.

I  have rewritten re-builder.el and got rid of its internal. Just need
to cleanup a bit. Now it is just a front end to isearch with more
editing capabilities, like rx. I think that can be useful.

I plan to keep three "regexp source styles" there and maybe rename
them a bit: regexp, string (or maybe read) and rx. I think those names
are self explanatory. Unfortunately re-builder now uses string/read
instead of regexp/string which is more user-level names.




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 9 Jun 2010 08:55:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 09 04:55:12 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OMH44-0005FQ-7z
	for submit <at> debbugs.gnu.org; Wed, 09 Jun 2010 04:55:12 -0400
Received: from smtp-out1.starman.ee ([85.253.0.3] helo=mx1.starman.ee)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <juri@HIDDEN>) id 1OMH42-0005FK-KH
	for 6227 <at> debbugs.gnu.org; Wed, 09 Jun 2010 04:55:11 -0400
X-Virus-Scanned: by Amavisd-New at mx1.starman.ee
Received: from mail.starman.ee (82.131.33.93.cable.starman.ee [82.131.33.93])
	by mx1.starman.ee (Postfix) with ESMTP id A51973F4147;
	Wed,  9 Jun 2010 11:55:04 +0300 (EEST)
From: Juri Linkov <juri@HIDDEN>
To: Lennart Borgman <lennart.borgman@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Organization: JURTA
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN>
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN>
	<AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN>
Date: Wed, 09 Jun 2010 11:36:38 +0300
In-Reply-To: <AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN>
	(Lennart Borgman's message of "Tue, 8 Jun 2010 15:37:50 +0200")
Message-ID: <8739ww1tjp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -3.6 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

> Here is a patch for the submatches highlighting.
> (It includes a bug fix for the prompt face too

What's a bug in the prompt face?

> and a help window scrolling I think is useful.)

Please provide an example of the scrolling bug too.

> The current faces does not look very well together so that must be fixed.

If current faces does not look well, then maybe we should completely
get rid of using re-builder.el in isearch, its faces and messy functions
like count-subexps, and to write this functionality for isearch from scratch.

Do you think something more complicated is necessary for this
functionality than the following simple code:

(defvar isearch-sub-overlays nil)
(add-hook 'isearch-update-post-hook
          (lambda ()
            ;; This code could be added to `isearch-highlight'.
            (mapc 'delete-overlay isearch-sub-overlays)
            (setq isearch-sub-overlays nil)
            (when isearch-regexp
              (dolist (i '(1 2 3 4))
                (when (match-beginning i)
                  (let ((ov (make-overlay (match-beginning i) (match-end i))))
                    (overlay-put ov 'face (intern-soft (format "isearch-%d" i)))
                    (overlay-put ov 'priority 1002)
                    (push ov isearch-sub-overlays)))))))

It relies on new faces `isearch-1', `isearch-2', `isearch-3', `isearch-4'.
As for face colors, I tried "magenta1", "magenta2", "magenta3", "magenta4"
for background colors, and they look good.

-- 
Juri Linkov
http://www.jurta.org/emacs/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 8 Jun 2010 13:38:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 08 09:38:21 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OLz0W-0004Nt-OX
	for submit <at> debbugs.gnu.org; Tue, 08 Jun 2010 09:38:21 -0400
Received: from mail-gw0-f44.google.com ([74.125.83.44])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OLz0U-0004Nm-2v
	for 6227 <at> debbugs.gnu.org; Tue, 08 Jun 2010 09:38:19 -0400
Received: by gwj15 with SMTP id 15so40680gwj.3
	for <6227 <at> debbugs.gnu.org>; Tue, 08 Jun 2010 06:38:12 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type;
	bh=VoaF/3dtNS0KSEgexIdfaYBNkTKgAOj8piKtVLReHSY=;
	b=oZTdEwpTsFOwOmFoUsUqiNtH4wX8Tl9B7Z5ohTx7e4vShd+zpS66j7a7MzJDlFOfBD
	7NTxVmKUa8wkKyP86y9gontY/uTSfrqVsN7obv3D2IgsTIHd4C2y80euC9rOjFov0qLB
	0UYPF7qSuOGLGKG9xM9+dAf6l0dTav6nmdJK0=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type;
	b=sq6CfLtLC5lxrWXV2FkrTSjrDdC/yvJXTtmIJqL+g6bbSRLq4I/b30zU/mDv97H1Er
	D0YdfmmMuS9blUxQvNfXjiQTxejmq5qVrwHzK6ZuQvhmPrmfhdz4fFAifeBZuIUUbd/2
	mRQ8xiK78DtW0oj8ACAgnjcRNPgvnXYi5adAc=
Received: by 10.101.132.26 with SMTP id j26mr16460747ann.144.1276004291310; 
	Tue, 08 Jun 2010 06:38:11 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.154.15 with HTTP; Tue, 8 Jun 2010 06:37:50 -0700 (PDT)
In-Reply-To: <AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN> 
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN> 
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN> 
	<874ohyppfs.fsf@HIDDEN>
	<AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Tue, 8 Jun 2010 15:37:50 +0200
Message-ID: <AANLkTileYK0D0RTKAePLbax_9o9JbgNlpuNXbLBzBssY@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Juri Linkov <juri@HIDDEN>
Content-Type: multipart/mixed; boundary=0016e6d2831883f6be048884e6ed
X-Spam-Score: -2.9 (--)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.9 (--)

--0016e6d2831883f6be048884e6ed
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

On Sun, May 23, 2010 at 6:40 PM, Lennart Borgman
<lennart.borgman@HIDDEN> wrote:
> On Sun, May 23, 2010 at 6:12 PM, Juri Linkov <juri@HIDDEN> wrote:
>>>> I think `reb-update-overlays' should be completely rewritten
>>>> for isearch.el.
>>>
>>> You surely know this things much better than me, but is there any
>>> reason to double the code?
>>
>> `reb-update-overlays' highlights all matches in the buffer.
>> This is like what lazy-highlighting does. =C2=A0But we agreed
>> that it should affect only the current isearch match,
>> not all lazy-highlighted matches.
>>
>>> If it is rewritten why not let re-builder share the same code?
>>
>> Yes, and query-replace highlighting could share it too.
>
>>>> The only thing we need from re-builder.el are faces
>>>> reb-match-1, reb-match-2, reb-match-3. =C2=A0We should try
>>>> using the existing faces for the same functionality.

Here is a patch for the submatches highlighting. (It includes a bug
fix for the prompt face too and a help window scrolling I think is
useful.)

The current faces does not look very well together so that must be fixed.

--0016e6d2831883f6be048884e6ed
Content-Type: text/x-patch; charset=US-ASCII; name="isearch-hisub-1.diff"
Content-Disposition: attachment; filename="isearch-hisub-1.diff"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_ga6rwn5o0
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--0016e6d2831883f6be048884e6ed--




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 23 May 2010 16:41:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 23 12:41:24 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OGEEu-0000SY-EU
	for submit <at> debbugs.gnu.org; Sun, 23 May 2010 12:41:24 -0400
Received: from mail-yw0-f203.google.com ([209.85.211.203])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OGEEt-0000ST-9r
	for 6227 <at> debbugs.gnu.org; Sun, 23 May 2010 12:41:23 -0400
Received: by ywh41 with SMTP id 41so1297651ywh.9
	for <6227 <at> debbugs.gnu.org>; Sun, 23 May 2010 09:41:18 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type
	:content-transfer-encoding;
	bh=1jn72dB8JEfcqWZReJYeDwJ6X7Ic1R83IL5J07PE8wQ=;
	b=e+SN1MFmr26FSFcKl681VOljJeyxwVDKcnekiP8eotDNrCVNAww91zghFGDkRLV0zV
	pwRejispOmvFpmxZOHLIpFajD8bttwxkqVbOIHvm8VurRa9bbfc8h0hMgmPqG0JStU6G
	oKsoWDfc63WMcmj7jKg3zSWR6RuYATs6Bkmp8=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type:content-transfer-encoding;
	b=NnEYklBF9T1MnL3XTNNaV99XQ/3e2WXx4R69Fq8n5vqXWRgkwpW+s3jF1WbIT654L4
	E91IdjQBG42YQKoXffAIt6zBUzCSIPg8ewMlYDwGhc0R6TgTjHwIDAuzKc2f0v88O70c
	vgcHiDCjt+67TYyJ5dHtKbJJgbFOrfW4EZwdU=
Received: by 10.100.246.26 with SMTP id t26mr5313097anh.112.1274632878268; 
	Sun, 23 May 2010 09:41:18 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.177.20 with HTTP; Sun, 23 May 2010 09:40:58 -0700 (PDT)
In-Reply-To: <874ohyppfs.fsf@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN> 
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN> 
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN> 
	<874ohyppfs.fsf@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Sun, 23 May 2010 18:40:58 +0200
Message-ID: <AANLkTilPUyzW5lCEdQv-WD6_0WdVbDiofmN34UHMVLNA@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.9 (--)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.9 (--)

On Sun, May 23, 2010 at 6:12 PM, Juri Linkov <juri@HIDDEN> wrote:
>>> I think `reb-update-overlays' should be completely rewritten
>>> for isearch.el.
>>
>> You surely know this things much better than me, but is there any
>> reason to double the code?
>
> `reb-update-overlays' highlights all matches in the buffer.
> This is like what lazy-highlighting does. =C2=A0But we agreed
> that it should affect only the current isearch match,
> not all lazy-highlighted matches.
>
>> If it is rewritten why not let re-builder share the same code?
>
> Yes, and query-replace highlighting could share it too.


I see. A misunderstanding, we mean the same. I wrote the
reb-update-overlays should be split and I meant then into one function
that hilights only one match (which is given as a parameter) and one
that loops for reb-update-overlays.


>>> The only thing we need from re-builder.el are faces
>>> reb-match-1, reb-match-2, reb-match-3. =C2=A0We should try
>>> using the existing faces for the same functionality.
>
> --
> Juri Linkov
> http://www.jurta.org/emacs/
>




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 23 May 2010 16:15:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 23 12:15:09 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OGDpV-0000Fw-6Q
	for submit <at> debbugs.gnu.org; Sun, 23 May 2010 12:15:09 -0400
Received: from smtp-out1.starman.ee ([85.253.0.3] helo=mx1.starman.ee)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <juri@HIDDEN>) id 1OGDpS-0000FK-W2
	for 6227 <at> debbugs.gnu.org; Sun, 23 May 2010 12:15:07 -0400
X-Virus-Scanned: by Amavisd-New at mx1.starman.ee
Received: from mail.starman.ee (82.131.98.186.cable.starman.ee [82.131.98.186])
	by mx1.starman.ee (Postfix) with ESMTP id 67AED3F40BD;
	Sun, 23 May 2010 19:14:59 +0300 (EEST)
From: Juri Linkov <juri@HIDDEN>
To: Lennart Borgman <lennart.borgman@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Organization: JURTA
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
	<877hmvtn9t.fsf@HIDDEN>
	<AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN>
Date: Sun, 23 May 2010 19:12:35 +0300
In-Reply-To: <AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN>
	(Lennart Borgman's message of "Sun, 23 May 2010 12:04:50 +0200")
Message-ID: <874ohyppfs.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -3.5 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.5 (---)

>> I think `reb-update-overlays' should be completely rewritten
>> for isearch.el.
>
> You surely know this things much better than me, but is there any
> reason to double the code?

`reb-update-overlays' highlights all matches in the buffer.
This is like what lazy-highlighting does.  But we agreed
that it should affect only the current isearch match,
not all lazy-highlighted matches.

> If it is rewritten why not let re-builder share the same code?

Yes, and query-replace highlighting could share it too.

>> The only thing we need from re-builder.el are faces
>> reb-match-1, reb-match-2, reb-match-3. =A0We should try
>> using the existing faces for the same functionality.

--=20
Juri Linkov
http://www.jurta.org/emacs/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 23 May 2010 10:05:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 23 06:05:15 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OG83W-00055S-Oh
	for submit <at> debbugs.gnu.org; Sun, 23 May 2010 06:05:14 -0400
Received: from mail-gw0-f44.google.com ([74.125.83.44])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OG83V-00055M-8O
	for 6227 <at> debbugs.gnu.org; Sun, 23 May 2010 06:05:13 -0400
Received: by gwj15 with SMTP id 15so252639gwj.3
	for <6227 <at> debbugs.gnu.org>; Sun, 23 May 2010 03:05:10 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type
	:content-transfer-encoding;
	bh=yjGZP5CNSc6iN7NUgJ8HyyBuznqQBXzKI9tAkNgDLiU=;
	b=fJz1E7Fe9RjHQOj2H3pfdMq4u7zWUonOWa3g2xZpkbFDMONFpTE/e8hL5BbK/R7Ua9
	Rr0LJdimf+hy/l8sx5Qi4Xci3IbPKZlqcB7ZcEA24VWSdWuXxGUh8WvNOJrcSQnrD/8j
	EjUcL0rkS0D+HUxFF8CB1O6fkA4pDEb6ey5G0=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type:content-transfer-encoding;
	b=YZDIuFOQlwf1yVDJPdN70VAWy5zMkJwgaej2+3xT0dn20Mc0clb4vn3Errr1er8EAD
	qfUXSh675oIn+fHmObmZqXnqfksq4HivqodxueduN0m5yfppkZMCyGEhvfUfw3teHL6D
	jVxGgnrJC2Obb7sHOSNN84o3oNDuql/EJ/JGI=
Received: by 10.101.143.5 with SMTP id v5mr4510907ann.178.1274609110134; Sun, 
	23 May 2010 03:05:10 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.177.20 with HTTP; Sun, 23 May 2010 03:04:50 -0700 (PDT)
In-Reply-To: <877hmvtn9t.fsf@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN> 
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN> 
	<877hmvtn9t.fsf@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Sun, 23 May 2010 12:04:50 +0200
Message-ID: <AANLkTiljPa2oALTtTabtFb3_KHhPB9NNqnKzXZWIh_v4@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -3.0 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.0 (---)

On Sun, May 23, 2010 at 2:54 AM, Juri Linkov <juri@HIDDEN> wrote:
>> Nice. So I suggest moving (and renaming) `reb-count-subexps' to
>> isearch.el and splitting off the marking of one overlay from
>> `reb-update-overlays' and moving that too to isearch.el (since
>> isearch.el) is probably always loaded for a normal Emacs user).
>
> I think `reb-update-overlays' should be completely rewritten
> for isearch.el.


You surely know this things much better than me, but is there any
reason to double the code? If it is rewritten why not let re-builder
share the same code?


> The only thing we need from re-builder.el are faces
> reb-match-1, reb-match-2, reb-match-3. =C2=A0We should try
> using the existing faces for the same functionality.




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 23 May 2010 01:45:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 22 21:45:46 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OG0GA-0001fU-DL
	for submit <at> debbugs.gnu.org; Sat, 22 May 2010 21:45:46 -0400
Received: from smtp-out1.starman.ee ([85.253.0.3] helo=mx1.starman.ee)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <juri@HIDDEN>) id 1OG0G8-0001fJ-57
	for 6227 <at> debbugs.gnu.org; Sat, 22 May 2010 21:45:45 -0400
X-Virus-Scanned: by Amavisd-New at mx1.starman.ee
Received: from mail.starman.ee (82.131.32.67.cable.starman.ee [82.131.32.67])
	by mx1.starman.ee (Postfix) with ESMTP id C58493F40F4;
	Sun, 23 May 2010 04:45:37 +0300 (EEST)
From: Juri Linkov <juri@HIDDEN>
To: Lennart Borgman <lennart.borgman@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Organization: JURTA
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
	<87wruv1ohr.fsf@HIDDEN>
	<AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
Date: Sun, 23 May 2010 03:54:34 +0300
In-Reply-To: <AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
	(Lennart Borgman's message of "Sun, 23 May 2010 02:51:48 +0200")
Message-ID: <877hmvtn9t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -3.5 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.5 (---)

> Nice. So I suggest moving (and renaming) `reb-count-subexps' to
> isearch.el and splitting off the marking of one overlay from
> `reb-update-overlays' and moving that too to isearch.el (since
> isearch.el) is probably always loaded for a normal Emacs user).

I think `reb-update-overlays' should be completely rewritten
for isearch.el.

The only thing we need from re-builder.el are faces
reb-match-1, reb-match-2, reb-match-3.  We should try
using the existing faces for the same functionality.

-- 
Juri Linkov
http://www.jurta.org/emacs/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 23 May 2010 00:52:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 22 20:52:15 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OFzQN-0001Id-7Y
	for submit <at> debbugs.gnu.org; Sat, 22 May 2010 20:52:15 -0400
Received: from mail-gw0-f44.google.com ([74.125.83.44])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OFzQK-0001IL-8Q
	for 6227 <at> debbugs.gnu.org; Sat, 22 May 2010 20:52:12 -0400
Received: by gwj15 with SMTP id 15so155978gwj.3
	for <6227 <at> debbugs.gnu.org>; Sat, 22 May 2010 17:52:08 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type
	:content-transfer-encoding;
	bh=z9cYEmer8mUnrxyGSXup2ZvgggR+2vuScmqEWR6djMA=;
	b=nKUr6DYsJrDz1GfsF/5g9fL3kyD1ZRcWF9fADyASaBmw+qB1T51PFIkQS9c3rLcCGz
	JmSAMmbOD79wgsGdBQxVmrM0s6GlDSqcwp+Tbqn25uX9pUIEG5ItZa/8TeIXRBGse+Gt
	uvgsQleQpSYyPqOw4In7fYG+BPhpvWIHHe8Vs=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type:content-transfer-encoding;
	b=S3gTLgzE+NlIitUFbcchU2XN1CVsdEE6Omfo4OSZaP9IQaG7C5MOwPuP9gUI5X9Zi6
	YmLj+XOI983tRDWDT2HYo0CArrejXZVc2SeOL5PbMPyvUbF3SU3O5fAgHV0nKZ5Wws09
	5VwKDg4EsYa/gYLe2ROPtlK7maLzOyImindio=
Received: by 10.100.26.12 with SMTP id 12mr4162513anz.177.1274575928149; Sat, 
	22 May 2010 17:52:08 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.177.20 with HTTP; Sat, 22 May 2010 17:51:48 -0700 (PDT)
In-Reply-To: <87wruv1ohr.fsf@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN> 
	<87wruv1ohr.fsf@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Sun, 23 May 2010 02:51:48 +0200
Message-ID: <AANLkTimRAHa4K6FlX_952j3s2saDmcXMIbDOYx9xk8Fh@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -3.1 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.0 (---)

On Sun, May 23, 2010 at 1:44 AM, Juri Linkov <juri@HIDDEN> wrote:
>>> We already have highlighting like that: lisp/emacs-lisp/re-builder.el
>>> uses faces `reb-match-1', `reb-match-2', `reb-match-3' to highlight
>>> regexp subexpressions. =C2=A0I think this should be used by isearch.
>>
>> That sounds right to me.
>>
>> Also Drew suggestion to not color submatches in lazy marking seems right=
.
>
> (add-hook 'isearch-update-post-hook
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(lambda ()
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(require 're-builder)
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(when isearch-regexp
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(let ((reb-regexp isearch=
-string)
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(reb=
-target-buffer (current-buffer))
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(reb=
-target-window (selected-window)))
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(reb-update-overla=
ys)))))
>
> (add-hook 'isearch-mode-end-hook
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(lambda ()
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(let ((reb-target-buffer (curren=
t-buffer)))
> =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0(reb-delete-overlays))))


Nice. So I suggest moving (and renaming) `reb-count-subexps' to
isearch.el and splitting off the marking of one overlay from
`reb-update-overlays' and moving that too to isearch.el (since
isearch.el) is probably always loaded for a normal Emacs user).




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 23 May 2010 00:39:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 22 20:39:06 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OFzDe-0001CJ-9f
	for submit <at> debbugs.gnu.org; Sat, 22 May 2010 20:39:06 -0400
Received: from smtp-out1.starman.ee ([85.253.0.3] helo=mx1.starman.ee)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <juri@HIDDEN>) id 1OFzDa-0001Bc-Ki
	for 6227 <at> debbugs.gnu.org; Sat, 22 May 2010 20:39:03 -0400
X-Virus-Scanned: by Amavisd-New at mx1.starman.ee
Received: from mail.starman.ee (82.131.32.67.cable.starman.ee [82.131.32.67])
	by mx1.starman.ee (Postfix) with ESMTP id EFA033F40F4;
	Sun, 23 May 2010 03:38:55 +0300 (EEST)
From: Juri Linkov <juri@HIDDEN>
To: Lennart Borgman <lennart.borgman@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Organization: JURTA
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<87bpca15ja.fsf@HIDDEN>
	<AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
Date: Sun, 23 May 2010 02:44:04 +0300
In-Reply-To: <AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
	(Lennart Borgman's message of "Fri, 21 May 2010 03:19:48 +0200")
Message-ID: <87wruv1ohr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -3.5 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.5 (---)

>> We already have highlighting like that: lisp/emacs-lisp/re-builder.el
>> uses faces `reb-match-1', `reb-match-2', `reb-match-3' to highlight
>> regexp subexpressions. =A0I think this should be used by isearch.
>
> That sounds right to me.
>
> Also Drew suggestion to not color submatches in lazy marking seems righ=
t.

(add-hook 'isearch-update-post-hook
          (lambda ()
	    (require 're-builder)
	    (when isearch-regexp
	      (let ((reb-regexp isearch-string)
		    (reb-target-buffer (current-buffer))
		    (reb-target-window (selected-window)))
		(reb-update-overlays)))))

(add-hook 'isearch-mode-end-hook
          (lambda ()
	    (let ((reb-target-buffer (current-buffer)))
	      (reb-delete-overlays))))

--=20
Juri Linkov
http://www.jurta.org/emacs/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 21 May 2010 01:20:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 21:20:13 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OFGuL-0002fa-Mt
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 21:20:13 -0400
Received: from mail-gw0-f44.google.com ([74.125.83.44])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OFGuK-0002fV-Ch
	for 6227 <at> debbugs.gnu.org; Thu, 20 May 2010 21:20:12 -0400
Received: by gwj23 with SMTP id 23so236951gwj.3
	for <6227 <at> debbugs.gnu.org>; Thu, 20 May 2010 18:20:08 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type
	:content-transfer-encoding;
	bh=l5TMfhEWxIo+GEozvQChc3+F6mjOLCl1tiTyfRyp14U=;
	b=psB2d3YBQ0r58+9miz495AkYUIQP1XUIOExQMi+VQx77H6Ay8lQ5fEOWmLO3GUqUgd
	581jTGaj5IGpx7Mu26iZZSCjpLXAmN8mIEyFAQgWGn6WB/Qt2Co6at9JICfF5GQZ1BgI
	QyJvJplwYoye7HQ5kqVWqf4+njQZi3Hg6xyNg=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type:content-transfer-encoding;
	b=jHT1oHAYJX79NlOTzP292NseP9jHyJOtPY4LHrPXzkGlfiHvh3Xvb+waHTRGytY2KX
	0ztv27bY/Ml1Myb1ce7jyqYuG0+BC4+WdnpJjXPmgesi8MLbinTLIdVT4RMfBhl+AZkG
	lSc+hUCMygWJqWXaa+SL+HEcvH44o1mFgnSnk=
Received: by 10.100.16.4 with SMTP id 4mr1198511anp.2.1274404808147; Thu, 20 
	May 2010 18:20:08 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.177.20 with HTTP; Thu, 20 May 2010 18:19:48 -0700 (PDT)
In-Reply-To: <87bpca15ja.fsf@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<87bpca15ja.fsf@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Fri, 21 May 2010 03:19:48 +0200
Message-ID: <AANLkTilV0TlRQRCC7-uAuspGAwTYhMySTbh4dOjKIDM0@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Juri Linkov <juri@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -3.7 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.5 (---)

On Fri, May 21, 2010 at 2:07 AM, Juri Linkov <juri@HIDDEN> wrote:
>> Just a suggestion, of course.
>
> We already have highlighting like that: lisp/emacs-lisp/re-builder.el
> uses faces `reb-match-1', `reb-match-2', `reb-match-3' to highlight
> regexp subexpressions. =C2=A0I think this should be used by isearch.

That sounds right to me.

Also Drew suggestion to not color submatches in lazy marking seems right.




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 21 May 2010 00:12:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 20:12:08 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OFFqR-0002B2-Mv
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 20:12:07 -0400
Received: from smtp-out1.starman.ee ([85.253.0.3] helo=mx1.starman.ee)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <juri@HIDDEN>) id 1OFFqP-0002Ab-Kq
	for 6227 <at> debbugs.gnu.org; Thu, 20 May 2010 20:12:06 -0400
X-Virus-Scanned: by Amavisd-New at mx1.starman.ee
Received: from mail.starman.ee (82.131.33.97.cable.starman.ee [82.131.33.97])
	by mx1.starman.ee (Postfix) with ESMTP id 3E3DC3F40C2;
	Fri, 21 May 2010 03:11:59 +0300 (EEST)
From: Juri Linkov <juri@HIDDEN>
To: Lennart Borgman <lennart.borgman@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
Organization: JURTA
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
Date: Fri, 21 May 2010 03:07:21 +0300
In-Reply-To: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	(Lennart Borgman's message of "Thu, 20 May 2010 13:01:37 +0200")
Message-ID: <87bpca15ja.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-Spam-Score: -3.5 (---)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.5 (---)

> Just a suggestion, of course.

We already have highlighting like that: lisp/emacs-lisp/re-builder.el
uses faces `reb-match-1', `reb-match-2', `reb-match-3' to highlight
regexp subexpressions.  I think this should be used by isearch.

-- 
Juri Linkov
http://www.jurta.org/emacs/




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 20 May 2010 15:03:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 11:03:45 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OF7Hl-0005rh-Ia
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 11:03:45 -0400
Received: from rcsinet10.oracle.com ([148.87.113.121])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1OF7Hj-0005rc-8C
	for 6227 <at> debbugs.gnu.org; Thu, 20 May 2010 11:03:43 -0400
Received: from acsinet15.oracle.com (acsinet15.oracle.com [141.146.126.227])
	by rcsinet10.oracle.com (Switch-3.4.2/Switch-3.4.1) with ESMTP id
	o4KF3aBZ012404
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Thu, 20 May 2010 15:03:37 GMT
Received: from acsmt353.oracle.com (acsmt353.oracle.com [141.146.40.153])
	by acsinet15.oracle.com (Switch-3.4.2/Switch-3.4.1) with ESMTP id
	o4KAoX7a027192; Thu, 20 May 2010 15:03:30 GMT
Received: from abhmt019.oracle.com by acsmt355.oracle.com
	with ESMTP id 284785061274367777; Thu, 20 May 2010 08:02:57 -0700
Received: from dradamslap1 (/130.35.178.194)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Thu, 20 May 2010 08:02:56 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Lennart Borgman'" <lennart.borgman@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN><A9C4B31B448A4B9AB2F4D4546A88A70B@HIDDEN><AANLkTim2L-BCkATdmWVLMOFNRFbiZoVoHDJNAdt3ytb9@HIDDEN>
	<D571867F93E243858CE155F6DB9206CA@HIDDEN>
Subject: RE: bug#6227: Color isearch regexp submatches differently
Date: Thu, 20 May 2010 08:02:53 -0700
Message-ID: <ABDB3C3F56F244C682C5DB02C15589D7@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.5931
In-reply-to: <D571867F93E243858CE155F6DB9206CA@HIDDEN>
Thread-Index: Acr4IFTelqrClbJ8QR6QAlq9gwXVlwAAIQ+AAAMSxpA=
X-Auth-Type: Internal IP
X-Source-IP: acsinet15.oracle.com [141.146.126.227]
X-CT-RefId: str=0001.0A090202.4BF54F49.0167:SCFMA922111,ss=1,fgs=0
X-Spam-Score: -6.1 (------)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.1 (------)

> > Yes, exactly.
> 
> IMO, this can be very helpful when searching with regexps.
> And it can help users learn about using regexps more generally.
> 
> Of course, such highlighting should be optional, and 
> preferably via a toggle
> during Isearch.

Need I add that this need not be shown for all search hits simultaneously
(costly and distracting to the user, in general). Just the current hit is
sufficient (what is shown now using face `isearch', not `lazy-highlight').





Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 20 May 2010 13:34:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 09:34:08 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OF5t1-0005C8-Vx
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 09:34:08 -0400
Received: from rcsinet10.oracle.com ([148.87.113.121])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1OF5sz-0005Bk-Vh
	for 6227 <at> debbugs.gnu.org; Thu, 20 May 2010 09:34:06 -0400
Received: from rcsinet15.oracle.com (rcsinet15.oracle.com [148.87.113.117])
	by rcsinet10.oracle.com (Switch-3.4.2/Switch-3.4.1) with ESMTP id
	o4KDXwXi018951
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Thu, 20 May 2010 13:34:00 GMT
Received: from acsmt355.oracle.com (acsmt355.oracle.com [141.146.40.155])
	by rcsinet15.oracle.com (Switch-3.4.2/Switch-3.4.1) with ESMTP id
	o4KDGFM5025183; Thu, 20 May 2010 13:33:57 GMT
Received: from abhmt006.oracle.com by acsmt355.oracle.com
	with ESMTP id 284464601274362436; Thu, 20 May 2010 06:33:56 -0700
Received: from dradamslap1 (/141.144.168.134)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Thu, 20 May 2010 06:33:56 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Lennart Borgman'" <lennart.borgman@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
	<A9C4B31B448A4B9AB2F4D4546A88A70B@HIDDEN>
	<AANLkTim2L-BCkATdmWVLMOFNRFbiZoVoHDJNAdt3ytb9@HIDDEN>
Subject: RE: bug#6227: Color isearch regexp submatches differently
Date: Thu, 20 May 2010 06:33:50 -0700
Message-ID: <D571867F93E243858CE155F6DB9206CA@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 11
Thread-Index: Acr4IFTelqrClbJ8QR6QAlq9gwXVlwAAIQ+A
In-Reply-To: <AANLkTim2L-BCkATdmWVLMOFNRFbiZoVoHDJNAdt3ytb9@HIDDEN>
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.5931
X-Auth-Type: Internal IP
X-Source-IP: rcsinet15.oracle.com [148.87.113.117]
X-CT-RefId: str=0001.0A090208.4BF53A48.00A7:SCFMA4539811,ss=1,fgs=0
X-Spam-Score: -6.1 (------)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.1 (------)

> > Did you mean something like this (attached)?
> > This is how I highlight submatches in Icicles search.
> >
> > (The top part of the image, with light blue background, 
> > shows the highlighting. The bottom part of the image,
> > with white background, shows the regexp used and
> > is just an explanation of the subgroup highlighting.)
> 
> Yes, exactly.

IMO, this can be very helpful when searching with regexps.
And it can help users learn about using regexps more generally.

Of course, such highlighting should be optional, and preferably via a toggle
during Isearch.





Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 20 May 2010 13:28:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 09:28:35 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OF5ne-000593-V0
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 09:28:35 -0400
Received: from mail-iw0-f172.google.com ([209.85.214.172])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OF5nc-00058y-PT
	for 6227 <at> debbugs.gnu.org; Thu, 20 May 2010 09:28:33 -0400
Received: by iwn42 with SMTP id 42so3767009iwn.3
	for <6227 <at> debbugs.gnu.org>; Thu, 20 May 2010 06:28:27 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:in-reply-to
	:references:from:date:message-id:subject:to:cc:content-type;
	bh=htLXSnAm06YiQ7Bt665gU/eW8KA9SRIajLwUkZtxld8=;
	b=BAJ4cojHiQTgtEE2rAKWl69Mf5xC/qeZDYaf0UoOU+avllma67a+hUUS/QdpuZ4acd
	pwR08s6+cfa4MfOui5mesy1cNQUcUW07wnAXsqYYFVCQI6EV7KGomJJo0jRbAk9cOFhy
	e35+LSeRinsui0aH5jiRVtZC2TQ+27K1hkgGc=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:in-reply-to:references:from:date:message-id:subject:to
	:cc:content-type;
	b=Jw+iq3c0gP0m6WuvBF1y+jaSUblzieX4+cRszxfyO5ZUvozSagqtw054wGA+2PPR1b
	Aq+YSxYiXeg0ajFF+RzLLIgotuC6kipfvea9yrkNd6WI1DyGpLl7KHlXIo+dyc5CTCP1
	MFTNX8te7qAJJlh+d83hduTlwyQqUhTrtDZec=
Received: by 10.231.167.144 with SMTP id q16mr42645iby.34.1274362107210; Thu, 
	20 May 2010 06:28:27 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.231.152.78 with HTTP; Thu, 20 May 2010 06:28:07 -0700 (PDT)
In-Reply-To: <A9C4B31B448A4B9AB2F4D4546A88A70B@HIDDEN>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN> 
	<A9C4B31B448A4B9AB2F4D4546A88A70B@HIDDEN>
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Thu, 20 May 2010 15:28:07 +0200
Message-ID: <AANLkTim2L-BCkATdmWVLMOFNRFbiZoVoHDJNAdt3ytb9@HIDDEN>
Subject: Re: bug#6227: Color isearch regexp submatches differently
To: Drew Adams <drew.adams@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -2.9 (--)
X-Debbugs-Envelope-To: 6227
Cc: 6227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.9 (--)

On Thu, May 20, 2010 at 3:21 PM, Drew Adams <drew.adams@HIDDEN> wrote:
> Did you mean something like this (attached)?
> This is how I highlight submatches in Icicles search.
>
> (The top part of the image, with light blue background, shows the highlighting.
> The bottom part of the image, with white background, shows the regexp used and
> is just an explanation of the subgroup highlighting.)

Yes, exactly.




Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at 6227 <at> debbugs.gnu.org:


Received: (at 6227) by debbugs.gnu.org; 20 May 2010 13:22:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 09:22:53 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OF5i9-000564-6I
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 09:22:53 -0400
Received: from rcsinet10.oracle.com ([148.87.113.121])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <drew.adams@HIDDEN>) id 1OF5i6-00055x-F0
	for 6227 <at> debbugs.gnu.org; Thu, 20 May 2010 09:22:51 -0400
Received: from acsinet15.oracle.com (acsinet15.oracle.com [141.146.126.227])
	by rcsinet10.oracle.com (Switch-3.4.2/Switch-3.4.1) with ESMTP id
	o4KDMdaS015436
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=OK);
	Thu, 20 May 2010 13:22:41 GMT
Received: from acsmt355.oracle.com (acsmt355.oracle.com [141.146.40.155])
	by acsinet15.oracle.com (Switch-3.4.2/Switch-3.4.1) with ESMTP id
	o4KBUbSC011324; Thu, 20 May 2010 13:22:37 GMT
Received: from abhmt021.oracle.com by acsmt355.oracle.com
	with ESMTP id 284424531274361695; Thu, 20 May 2010 06:21:35 -0700
Received: from dradamslap1 (/141.144.168.134)
	by default (Oracle Beehive Gateway v4.0)
	with ESMTP ; Thu, 20 May 2010 06:21:34 -0700
From: "Drew Adams" <drew.adams@HIDDEN>
To: "'Lennart Borgman'" <lennart.borgman@HIDDEN>, <6227 <at> debbugs.gnu.org>
References: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
Subject: RE: bug#6227: Color isearch regexp submatches differently
Date: Thu, 20 May 2010 06:21:32 -0700
Message-ID: <A9C4B31B448A4B9AB2F4D4546A88A70B@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed;
	boundary="----=_NextPart_000_0000_01CAF7E4.B150FF00"
X-Mailer: Microsoft Office Outlook 11
Thread-Index: Acr4FE97jcmMRn5MR5GpHlbYVLAIZgAChKxQ
In-Reply-To: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2900.5931
X-Auth-Type: Internal IP
X-Source-IP: acsinet15.oracle.com [141.146.126.227]
X-CT-RefId: str=0001.0A090208.4BF537A3.0011:SCFMA922111,ss=1,fgs=0
X-Spam-Score: -4.8 (----)
X-Debbugs-Envelope-To: 6227
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.1 (------)

This is a multi-part message in MIME format.

------=_NextPart_000_0000_01CAF7E4.B150FF00
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit

Did you mean something like this (attached)?
This is how I highlight submatches in Icicles search.

(The top part of the image, with light blue background, shows the highlighting.
The bottom part of the image, with white background, shows the regexp used and
is just an explanation of the subgroup highlighting.)


------=_NextPart_000_0000_01CAF7E4.B150FF00
Content-Type: image/png;
	name="drew-emacs-icicle-search-context-colors.png"
Content-Transfer-Encoding: base64
Content-Disposition: attachment;
	filename="drew-emacs-icicle-search-context-colors.png"
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------=_NextPart_000_0000_01CAF7E4.B150FF00--





Information forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 May 2010 11:12:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 20 07:12:47 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OF3gE-0003af-IP
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 07:12:46 -0400
Received: from mail.gnu.org ([199.232.76.166] helo=mx10.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OF3gC-0003aa-Ia
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 07:12:45 -0400
Received: from lists.gnu.org ([199.232.76.165]:39545)
	by monty-python.gnu.org with esmtps
	(TLS-1.0:DHE_RSA_AES_256_CBC_SHA1:32) (Exim 4.60)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OF3g7-0000QB-4p
	for submit <at> debbugs.gnu.org; Thu, 20 May 2010 07:12:39 -0400
Received: from [140.186.70.92] (port=45192 helo=eggs.gnu.org)
	by lists.gnu.org with esmtp (Exim 4.43) id 1OF3WA-0005cL-63
	for bug-gnu-emacs@HIDDEN; Thu, 20 May 2010 07:02:40 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.1 (2010-03-16) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_NONE,T_DKIM_INVALID autolearn=unavailable version=3.3.1
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OF3W3-0001k8-Hm
	for bug-gnu-emacs@HIDDEN; Thu, 20 May 2010 07:02:21 -0400
Received: from mail-gw0-f41.google.com ([74.125.83.41]:44459)
	by eggs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <lennart.borgman@HIDDEN>) id 1OF3Vy-0001j2-IU
	for bug-gnu-emacs@HIDDEN; Thu, 20 May 2010 07:02:11 -0400
Received: by gwb20 with SMTP id 20so6590790gwb.0
	for <bug-gnu-emacs@HIDDEN>; Thu, 20 May 2010 04:02:08 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=gamma;
	h=domainkey-signature:received:mime-version:received:from:date
	:message-id:subject:to:content-type;
	bh=XhJjsxQw9FSKfUMv1QXTMaeQtTvd3dQZCnxB6XRvex8=;
	b=GNn1Ar94E+HiY5OZmDCA75F4v2gaQAfJLEsYFpzpJNcvv/aYlWEviTQIbzPlhs6UuZ
	UElri4W3RlyqwKPih99lB6BhakTwrooWquhpM22/zz21mtvBTeHP0EhkdsWda6d80vWP
	iJyHFvoR/RVZbsgWc8MuYyffVlFdknxZ0DLWc=
DomainKey-Signature: a=rsa-sha1; c=nofws; d=gmail.com; s=gamma;
	h=mime-version:from:date:message-id:subject:to:content-type;
	b=U+U5JSqS7ao91y2YE3iZ36z2bJTRFp0lKebgPbqSEUdj/cuutAP+ytczsVeY1V0P5G
	zAaQGo01VQRrCoRAVgb2OSi2kSn+JZjmlXmfJsOhMQ5gkzhXSeDZcRtNHiCdEMMwIypV
	lO51LLPJONYTTvE+GoVJhTAvrdF93Y6665ZaM=
Received: by 10.101.178.8 with SMTP id f8mr12156649anp.213.1274353317154; Thu, 
	20 May 2010 04:01:57 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.100.225.13 with HTTP; Thu, 20 May 2010 04:01:37 -0700 (PDT)
From: Lennart Borgman <lennart.borgman@HIDDEN>
Date: Thu, 20 May 2010 13:01:37 +0200
Message-ID: <AANLkTikUlBKGt388RPJkU8tM6A_fpMPsTkvo6cbI3D56@HIDDEN>
Subject: Color isearch regexp submatches differently
To: Emacs Bugs <bug-gnu-emacs@HIDDEN>
Content-Type: text/plain; charset=UTF-8
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 2)
X-detected-operating-system: by monty-python.gnu.org: GNU/Linux 2.6,
	seldom 2.4 (older, 4)
X-Spam-Score: -5.1 (-----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -5.2 (-----)

Just a suggestion, of course.




Acknowledgement sent to Lennart Borgman <lennart.borgman@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6227; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.